/*
  Program: Pikvorky - rozhod
  Pomocn program pro sehrn zpasu v pikvorkch
  
  Autor: Radek Pelnek  
  Ploha ke knize "Jak to vyeit",  www.radekpelanek.cz/?jtv
*/

#include <iostream>
#define X 1
#define O 2
#include <cstdlib>
#include <string>

using namespace std;

// krizek  1
// kolecko 

int pole[22][22];
int moje;

int smerX[8] = {0, 1, 1, 1, 0, -1, -1, -1};
int smerY[8] = {-1, -1, 0, 1, 1, 1, 0, -1};

char dej_char(int pom) {
  if (pom == X) return 'X';
  if (pom == O) return 'O';
  return '.';
}

void inicializace() {
  for (int i=0; i<22; i++)
    for (int j=0; j<22; j++)
      pole[i][j] = 0;
}

void read() {
  char ch;
  cin >> ch;
  if (ch == 'X') moje = X; else moje = O; 

  for (int i=1; i<=20; i++)
    for (int j=1; j<=20; j++) {
      cin >> ch;
      if (ch == 'X') pole[i][j] = X;      
      if (ch == 'O') pole[i][j] = O;
    }
}

void posun(int* x, int* y, int smer, int pocet) {
  *x = *x + smerX[smer]*pocet;  
  *y = *y + smerY[smer]*pocet;
}

bool out(int x, int y) {
  return (x<=0 || y<= 0|| x>20 ||y>20);
}

bool test(int x, int y, int smer, string co) {
  int i = 0;
  while (i < co.length()) {
    if (out(x,y)) return false;
    if (dej_char(pole[x][y]) != co[i]) {      
      return false;
    }
    posun(&x, &y, smer, 1);
    i++;
  }
  return true;
}

bool hledej(string co, int* x, int* y, int* smer) {
  for (int i=1; i<=20; i++)
    for (int j=1; j<=20; j++)
      for (int s=0; s<8; s++) {
	if (test(i,j,s,co)) {
	  *x = i; *y = j; *smer = s;
	  return true;
	}
      }
  return false;
}

int hledej_viteze() {
  int x,y,s;
  if (hledej("XXXXX",&x,&y,&s)) return X;
  if (hledej("OOOOO",&x,&y,&s)) return O;
  return 0;
}


int main() {

  inicializace();

  read();

  int v = hledej_viteze();
  if (v==X) cout <<"X"<<endl;
  else if (v==O) cout <<"O"<<endl;
  else cout << "-"<<endl;

  return 0;
}
